.\"	$NetBSD: x86_64_iopl.2,v 1.4 2003/04/16 13:34:35 wiz Exp $
.\"
.\" Copyright (c) 1996 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by John T. Kohl and Charles M. Hannum.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd July 3, 2002
.Dt X86_64_IOPL 2 x86_64
.Os
.Sh NAME
.Nm x86_64_iopl
.Nd change the x86_64 I/O privilege level
.Sh LIBRARY
.Lb libx86_64
.Sh SYNOPSIS
.In sys/types.h
.In machine/sysarch.h
.Ft int
.Fn x86_64_iopl "int iopl"
.Sh DESCRIPTION
.Fn x86_64_iopl
sets the x86_64 I/O privilege level to the value specified by
.Ar iopl .
This call is restricted to the super-user.
.Sh RETURN VALUES
Upon successful completion,
.Fn x86_64_iopl
returns 0.
Otherwise, a value of \-1 is returned and the global
variable
.Va errno
is set to indicate the error.
.Sh ERRORS
.Fn x86_64_iopl
will fail if:
.Bl -tag -width [EINVAL]
.It Bq Er EPERM
The caller was not the super-user, or the operation was not permitted at the
current security level.
.El
.Sh WARNING
You can really hose your machine if you enable user-level I/O and
write to hardware ports without care.
